<template>
  <div style="margin-bottom: 100px">
    <Ariane
      type="breadcrumb trunk"
      :breadcrumbs="breadcrumbs"
      :params="params"
    />
    <div class="trunk">
      <div class="banner-catalog_left">
        <h1 class="heading--xl heading--primary heading--uppercase">
          {{ $t('profile.edit') }}
        </h1>
      </div>
    </div>

    <div class="trunk">
      <div v-if="!isLoading">
        <h3 class="text--md text--bold">{{ $t('profile.picture') }}</h3>
        <div class="user_image">
          <img
            :src="getAvatarUrl"
            :alt="user.login"
            class="banner-serie_image responsively-lazy"
          />
          <input
            id="file"
            ref="file"
            type="file"
            hidden
            @change="handleFileUpload()"
          />
          <button class="button button_sm button_shape" @click="chooseFiles()">
            {{ $t('profile.editPicture') }}
          </button>
        </div>
        <div class="form-part">
          <h3 class="text--md text--bold">{{ $t('profile.description') }}</h3>
          <textarea v-model="description" rows="5"></textarea>
        </div>
        <div class="form-part">
          <button class="button button_md button_full" @click="postBio()">
            {{ $t('settings.save') }}
          </button>
        </div>
      </div>
      <Loader v-else :display="isLoading" />
    </div>
  </div>
</template>

<script>
import Loader from '~/components/ui/Loader'
import Ariane from '~/components/ui/Ariane'

export default {
  name: 'ProfilEdit',
  components: { Ariane, Loader },

  async fetch() {
    await this.loadProfile()
  },

  data() {
    return {
      breadcrumbs: [
        this.$t('breadcrumb.home'),
        this.$t('breadcrumb.profile'),
        this.$t('breadcrumb.edit')
      ],
      params: [this.localePath({ name: 'index' }), '', null],
      user: [],
      description: '',
      isLoading: false,
      file: ''
    }
  },

  computed: {
    getAvatarUrl() {
      return `${this.$config.izneoUrl}/${this.$i18n.locale}/images/avatar/${this.user.id}-250x250.jpg?v=${this.user.avatarCacheVersion}`
    }
  },

  methods: {
    async loadProfile() {
      this.isLoading = true
      try {
        const data = await this.$api.profil(0)
        this.user = data.user
      } finally {
        this.params = [
          this.localePath({ name: 'index' }),
          this.localePath({ name: 'profil-id', params: { id: this.user.id } })
        ]
        this.description = this.user.public.description

        this.isLoading = false
      }
    },
    async handleFileUpload() {
      const elt = this
      this.file = this.$refs.file.files[0]

      const formData = new FormData()

      formData.append('avatar', this.file)

      try {
        await this.$api.postAvatarForm(formData)
      } finally {
        elt.user.avatarCacheVersion = Date.now()
      }
    },

    chooseFiles() {
      document.getElementById('file').click()
    },

    async postBio() {
      try {
        await this.$api.postBio(this.description)
      } finally {
        this.$toast.success(this.$t('settings.saved'), {
          icon: { name: 'icon icon-check' }
        })
      }
    }
  },

  head() {
    return {
      titleTemplate: this.$t('breadcrumb.profile')
    }
  }
}
</script>

<style
  lang="scss"
  src="~/assets/scss/v7/components/organisms/banner-catalog/_banner-catalog.scss"
></style>

<style scoped lang="scss">
.user_image {
  img {
    border-radius: 50%;
    width: 100px;
  }
}

.form-part {
  margin-top: 40px;

  textarea {
    width: 70%;
  }
}
</style>
